/*
 Esercizi 1-2 lezione 23/03



 Nota: a differenza del testo originale degli esercizi, dove ogni sottoarray è inteso  
 estremo destro escluso, in questa soluzione si assume ogni sottoarray specificato 
 con estremo destro incluso (per uniformarsi allo pseudocodice visto a lezione). 

  Ad esempio: 
    MergeSort(A,0,99) ordina tutti gli elementi di A da A[0] ad A[99] incluso 

*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>


void Merge(int *A, int p, int q, int r){

 int ai=p;
 int bi=q+1;
 int ci=0;
 int *C= (int*)malloc(sizeof(int)*(r-p+1));
 

 while (ai <= q && bi <= r){

   if (A[ai] <= A[bi]) 
       C[ci++] = A[ai++];
   else
       C[ci++] = A[bi++];

 }

 for (;ai <= q; ai++) C[ci++] = A[ai];

 for (;bi <= r; bi++) C[ci++] = A[bi];

 for (ci=0; ci < (r-p+1); ci++) 
	 A[p+ci]=C[ci];

 free(C);
}

void MergeSort(int *A, int p, int q){

int mid;

if (p < q){

 mid=(p+q)/2;
 MergeSort(A,p,mid);
 MergeSort(A,mid+1,q);
 Merge(A,p,mid,q);

}

return;
}


int main(){

int A[100];
int i;
srand(time(NULL));

printf("Prova MergeSort.\n");
printf("Inserisco un centinaio di valori casuali in un array: \n");
for (i=0; i<100; i++) 
  A[i] = (rand()%1000);

for (i=0; i< 100; i++) 
 printf("%d ", A[i]);
printf("\n");

MergeSort(A,0,99);

printf("\nora li ordino chiamando merge_sort: \n");
for (i=0; i< 100; i++) printf("%d ", A[i]);
return 0;

}

